<?php

namespace CreoCode\ContaoTourismBundle\Models;

use Contao\Model\Collection;

use Contao\Model;
use Contao\Date;

/**
 * Reads and writes offers sets
 *
 * @property integer $id
 * @property integer $tstamp
 * @property string  $title
 * @property integer $jumpTo
 * @property boolean $protected
 * @property string  $groups
 *
 * @method static OffersSetModel|null findById($id, array $opt=array())
 * @method static OffersSetModel|null findByPk($id, array $opt=array())
 * @method static OffersSetModel|null findByIdOrAlias($val, array $opt=array())
 * @method static OffersSetModel|null findOneBy($col, $val, array $opt=array())
 * @method static OffersSetModel|null findOneByTstamp($val, array $opt=array())
 * @method static OffersSetModel|null findOneByTitle($val, array $opt=array())
 * @method static OffersSetModel|null findOneByJumpTo($val, array $opt=array())
 * @method static OffersSetModel|null findOneByProtected($val, array $opt=array())
 * @method static OffersSetModel|null findOneByGroups($val, array $opt=array())
 *
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findByTstamp($val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findByTitle($val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findByJumpTo($val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findByProtected($val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findByGroups($val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findMultipleByIds($val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findBy($col, $val, array $opt=array())
 * @method static Collection|OffersSetModel[]|OffersSetModel|null findAll(array $opt=array())
 *
 * @method static integer countById($id, array $opt=array())
 * @method static integer countByTstamp($val, array $opt=array())
 * @method static integer countByTitle($val, array $opt=array())
 * @method static integer countByJumpTo($val, array $opt=array())
 * @method static integer countByProtected($val, array $opt=array())
 * @method static integer countByGroups($val, array $opt=array())
 *
 */
class OffersSetModel extends Model
{

	/**
	 * Table name
	 * @var string
	 */
	protected static $strTable = 'tl_offers_set';

}

class_alias(OffersSetModel::class, 'OffersSetModel');
